
#line 3 "lexer.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 81
#define YY_END_OF_BUFFER 82
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[383] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   82,   80,   79,   79,   80,   80,   80,   34,
       56,   80,   80,   80,   80,   61,   80,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   35,   36,   55,
       79,   56,   80,   80,   80,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   72,   71,   71,   72,
       72,   62,   64,   63,   69,   69,   69,   44,   44,   43,
       42,   41,   33,   31,   31,   33,   33,   33,    9,   33,
       12,   13,    7,   10,    6,   11,    8,   27,   27,   19,
       33,   20,   32,   32,   32,   32,   32,   32,   32,    0,

        0,   78,    0,    0,   60,   60,   60,   58,   66,   61,
        0,   61,   61,   61,   61,    1,   61,   61,   61,   61,
       61,   61,    0,    0,    0,    0,    0,    0,    0,    0,
       60,    0,    0,    0,   61,   61,   61,   61,   61,   61,
        1,   61,   61,   61,   61,   61,   61,    0,   65,    0,
        0,   70,   63,   69,   69,   68,   45,   41,   17,    0,
       30,    0,    0,   28,    0,   29,    0,   67,   25,    0,
       27,   15,   18,   14,   16,   32,   32,   32,   32,    3,
       32,   32,    0,   74,    0,   73,    0,    0,   76,    0,
       60,   60,   57,   57,   58,   59,   61,   61,   61,   61,

       61,   61,   61,   61,   61,   61,   61,   54,    0,   77,
       60,    0,    0,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,    0,   28,   26,    4,   32,    5,
       32,   32,    0,   75,   60,   57,   57,   59,   61,   61,
       39,   61,   61,   61,   61,   61,   61,   38,   61,    0,
        0,    0,   61,   61,   39,   61,   61,   61,   61,   61,
       61,   38,   61,    0,   32,   32,    2,   61,   61,   61,
       61,   61,   61,   61,   61,   61,    0,    0,   61,   61,
       61,   61,   61,   61,   61,   61,   61,    0,   32,   32,
       61,   61,   61,    0,   50,   61,   61,   61,   61,   61,

        0,    0,   61,   61,   61,   61,   61,   61,   61,   61,
       32,   32,    0,   52,   61,    0,   46,    0,   51,   61,
       61,   37,   61,    0,   53,   61,   61,   61,   37,   61,
       32,   32,   61,   61,   61,   61,   61,   61,   61,   61,
       21,   32,    0,   49,   61,    0,   48,    0,   47,   61,
       32,   32,   61,   61,   22,   23,   61,   61,   32,   61,
       61,   24,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       40,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
       13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
       21,   21,   21,   21,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   39,   40,   41,   42,   43,   44,
       39,   45,   46,   47,   48,   49,   50,   51,   52,   39,
        1,   53,    1,   29,   54,    1,   55,   56,   57,   58,

       59,   60,   61,   62,   63,   39,   39,   64,   65,   66,
       67,   68,   39,   69,   70,   71,   72,   49,   73,   74,
       75,   39,   76,   29,   77,   78,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[79] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    1,    1,
        6,    1,    1,    8,    9,   10,   11,   12,    1,   13,
       13,   14,   15,   16,    1,   17,    1,    6,    1,   18,
       18,   19,   19,   19,   18,   20,   20,   20,   20,   20,
       20,   21,   20,   20,   21,   20,   21,   20,   21,   20,
       20,   20,    6,   22,   18,   18,   19,   19,   19,   18,
       20,   20,   20,   20,   20,   21,   20,   20,   21,   20,
       21,   20,   20,   20,   20,    1,    1,    1
    } ;

static yyconst flex_int16_t yy_base[436] =
    {   0,
        0,   78,  156,    0,  232,  233,  235,  238,  230,  235,
      257,    0, 1140, 2339, 2339, 2339,    0, 1136,    0, 2339,
     2339, 1091,  230,    0, 1080,    0,    0,  304,  295,  299,
      300,  306,  300,  299,  297,  299,  315, 2339, 2339,    0,
      356,  332, 1063,  379,  334,  395,  420,  444,  335,  357,
      387,  334,  400,  403,  429,  443, 2339, 2339, 2339,  370,
     1065, 2339, 2339,    0, 1052, 1045, 1003,    0, 2339, 2339,
     2339,  458, 2339, 2339, 2339,  950,  420,  406, 2339,  407,
     2339, 2339, 2339, 2339, 2339, 2339,  945,  461,  463,  227,
      851,  843,  354,    0,  396,  428,  444,  443,  320,  489,

      863, 2339,  535,  501,    0,  513,  422,    0, 2339,    0,
      837,  447,  455,  453,  458,    0,  462,  474,  580,  469,
      573,  576,  620,  506,  745,  736,  600,    0,  607,  628,
      647,  732,  630,  661,  601,  649,  642,  637,  644,  621,
      643,  648,  662,  659,  679,  654,  665,  688, 2339,  508,
      696, 2339,    0,  642,  633, 2339,    0,  713, 2339,  692,
     2339,  627,    0,    0,  685, 2339,  618, 2339,  707,    0,
      727, 2339, 2339, 2339, 2339,    0,  679,  665,  689,    0,
      687,  705,  748, 2339,  623, 2339,  764,  751,  841,  616,
      847,  612,    0,    0,    0,    0,  808,  806,  813,  822,

      807,  808,  813,  814,  825,  817,  818,    0,  759, 2339,
      861,  343,  752,  830,  824,  840,  844,  847,  853,  845,
      859,  872,  861,  865,  915,    0, 2339,    0,  845,    0,
      853,  868,  531, 2339,  519,    0,    0,    0,  874,  871,
        0,  893,  883,  897,  893,  890,  894,    0,  903,  940,
      942,  947,  907,  910,  912,  928,  913,  926,  927,  939,
      932,  922,  945,  980,  961,  940,    0,  955,  962,  963,
     1011,  970,  964,  963,  971,  980,  515,  444,  976,  994,
      996, 1042,  991,  985,  995, 1013, 1023, 1014,  988,  995,
     1067, 1015, 1071, 1084, 2339, 1089, 1027, 1029, 1035, 1042,

     1091,  482, 1100, 1056, 1112, 1115, 1078, 1082, 1083, 1085,
     1065, 1061, 1134, 2339, 1073, 1157, 2339, 1160, 2339, 1073,
     1090,    0, 1107,  425,  422, 1104, 1133, 1131, 1114, 1143,
     1124, 1110, 1185, 1140, 1205, 1209, 1212, 1180, 1223, 1226,
      311, 1133, 1229, 2339, 1155, 1242, 2339, 1246, 2339, 1196,
     1196, 1200, 1206, 1208,    0,  283, 1156, 1213, 1219, 1223,
     1233,    0, 1222, 1231, 1236, 1244, 1226, 1241, 1233, 1246,
     1244, 1258, 1260, 1271, 1270, 1272, 1265, 1274,  233, 1308,
     2339, 2339, 1375, 1397, 1419, 1441, 1463, 1468, 1489, 1511,
     1525, 1535, 1555, 1569, 1583, 1604, 1620, 1634, 1656, 1678,

     1689, 1711, 1733, 1755, 1773, 1794, 1804, 1826, 1848, 1864,
     1881, 1902, 1921, 1937, 1958, 1969, 1991, 2013, 2035, 2040,
     2051, 2073, 1172, 2083, 2105, 2127, 2149, 2171, 2193, 2215,
     2237, 2259, 2277, 2295, 2316
    } ;

static yyconst flex_int16_t yy_def[436] =
    {   0,
      382,  382,  382,    3,  383,  383,  384,  384,  385,  385,
      382,   11,  382,  382,  382,  382,  386,  387,  388,  382,
      382,  382,  389,  389,  390,  391,  392,  391,  391,  391,
      391,  391,  391,  391,  391,  391,  391,  382,  382,  389,
      393,  394,  395,  396,  397,  398,  398,  398,   48,   48,
       48,   48,   48,   48,   48,   48,  382,  382,  382,  399,
      400,  382,  382,  401,  402,  402,  382,  403,  382,  382,
      382,  382,  382,  382,  382,  382,  404,  405,  382,  406,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  407,  407,  407,  407,  407,  407,  407,  386,

      387,  382,  382,  382,  389,  389,  408,  409,  382,  391,
      392,  391,  391,  391,  391,  391,  391,  391,  391,  391,
      391,  391,  393,  394,  395,  410,  394,  411,  382,  395,
      412,  410,  410,  413,   48,  391,   48,   48,   48,   48,
       48,   48,   48,   48,   48,   48,   48,  399,  382,  414,
      415,  382,  416,  417,  417,  382,  418,  382,  382,  419,
      382,  382,  420,  421,  422,  382,  382,  382,  382,  423,
      382,  382,  382,  382,  382,  424,  424,  424,  424,  424,
      424,  424,  382,  382,  425,  382,  382,  382,  382,  426,
      427,  428,  429,  430,  431,  432,  391,  391,  391,  391,

      391,  391,  391,  391,  391,  391,  391,  433,  382,  382,
      427,  382,  434,   48,   48,   48,   48,   48,   48,   48,
       48,   48,   48,   48,  399,  421,  382,  424,  424,  424,
      424,  424,  426,  382,  428,  429,  430,  432,  391,  391,
      391,  391,  391,  391,  391,  391,  391,  391,  391,  434,
      434,  434,   48,   48,   48,   48,   48,   48,   48,   48,
       48,   48,   48,  399,  424,  424,  424,  391,  391,  391,
      391,  391,  391,  391,  391,  391,  382,  382,   48,   48,
       48,   48,   48,   48,   48,   48,   48,  399,  424,  424,
      391,  391,  391,  382,  382,  391,  391,  391,  391,  391,

      382,  435,   48,   48,   48,   48,   48,   48,   48,   48,
      424,  424,  382,  382,  391,  382,  382,  382,  382,  391,
      391,  391,  391,  435,  435,   48,   48,   48,   48,   48,
      424,  424,  391,  391,  391,  391,   48,   48,   48,   48,
      424,  424,  382,  382,  391,  382,  382,  382,  382,   48,
      424,  424,  391,   48,  424,  424,  391,   48,  424,  391,
       48,  424,  391,   48,  391,   48,  391,   48,  391,   48,
      391,   48,  391,   48,  391,   48,  391,   48,  391,   48,
      382,    0,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,

      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382
    } ;

static yyconst flex_int16_t yy_nxt[2418] =
    {   0,
       14,   15,   16,   15,   17,   14,   18,   19,   14,   20,
       14,   14,   14,   21,   22,   14,   23,   24,   25,   26,
       26,   26,   27,   14,   14,   14,   24,   24,   24,   28,
       26,   29,   26,   30,   26,   31,   26,   32,   26,   26,
       33,   26,   26,   34,   35,   36,   37,   26,   26,   26,
       26,   26,   14,   26,   28,   26,   29,   26,   30,   26,
       31,   26,   32,   26,   33,   26,   26,   34,   35,   36,
       37,   26,   26,   26,   26,   38,   39,   40,   14,   41,
       16,   41,   17,   14,   18,   19,   14,   20,   14,   14,
       14,   42,   43,   14,   44,   24,   25,   26,   26,   26,

       45,   14,   14,   14,   24,   24,   24,   46,   47,   48,
       47,   49,   47,   50,   47,   51,   47,   47,   52,   47,
       47,   53,   54,   55,   56,   47,   47,   47,   47,   47,
       14,   26,   46,   47,   48,   47,   49,   47,   50,   47,
       51,   47,   52,   47,   47,   53,   54,   55,   56,   47,
       47,   47,   47,   38,   39,   40,   57,   58,   59,   58,
       57,   60,   61,   57,   57,   57,   57,   57,   62,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   63,   57,   57,   57,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,

       64,   64,   64,   64,   64,   64,   64,   64,   57,   57,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   57,   57,   57,   66,   66,   69,   69,   69,   69,
       69,   69,   71,  106,  381,   67,   67,   71,  107,   72,
       72,   72,  172,  173,   72,   72,   72,   73,   74,   75,
       74,   76,   77,   73,   78,   79,   73,   80,   81,   82,
       83,   84,   85,   86,   73,   87,   88,   89,   89,   73,
       73,   90,   91,   92,   73,   73,   93,   94,   95,   94,
       94,   94,   94,   94,   94,   94,   94,   94,   96,   97,

       94,   94,   98,   99,   94,   94,   94,   94,   94,   73,
       73,   93,   94,   95,   94,   94,   94,   94,   94,   94,
       94,   94,   96,   97,   94,   94,   98,   99,   94,   94,
       94,   94,   73,   73,   73,  112,  359,  113,  114,  115,
      116,  132,  118,  119,  120,  121,  212,  117,  122,  128,
      133,  129,  129,  111,  111,  111,  182,  123,  213,  123,
      112,  113,  114,  115,  351,  116,  118,  119,  120,  121,
      125,  117,  125,  122,  139,  149,  143,  135,  126,  105,
      105,  182,  105,  105,  105,  105,  105,  105,  105,  105,
      105,  105,  106,  105,  105,  177,  140,  107,  139,  135,

      143,  135,  105,  105,  105,  105,  105,  105,  127,  110,
      163,  110,  128,  163,  136,  136,  110,  166,  110,  177,
      140,  141,  150,  135,  194,  161,  137,  325,  142,  135,
      325,  105,  105,  127,  110,  105,  110,  128,  178,  136,
      136,  110,  135,  110,  144,  135,  141,  301,  110,  302,
      145,  137,  142,  135,  105,  105,  105,  127,  110,  167,
      110,  128,  178,  136,  136,  110,  135,  110,  144,  135,
      179,  135,  162,  110,  145,  146,  147,  158,  158,  158,
      169,  169,  171,  171,  171,  135,  138,  325,  180,  181,
      183,  184,  183,  197,  179,  135,  198,  110,  199,  146,

      200,  147,  188,  189,  188,  201,  202,  190,  205,  135,
      138,  170,  180,  181,  191,  189,  191,  197,  277,  192,
      198,  234,  199,  128,  200,  129,  129,  225,  225,  201,
      278,  202,  205,  234,  170,  185,  185,  186,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  185,  185,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,

      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      185,  185,  185,  203,  234,  206,  207,  128,  234,  129,
      129,  123,  204,  123,  128,  186,  129,  129,  165,  209,
      210,  209,  160,  212,  125,  155,  125,  382,  203,  206,
      207,  382,  126,  135,  155,  213,  204,  105,  211,  210,
      211,  105,  105,  105,  105,  105,  105,  105,  105,  105,
      105,  105,  105,  217,  212,  105,  128,  135,  136,  136,
      105,  105,  105,  105,  105,  105,  213,  133,  215,  135,
      111,  111,  111,  196,  135,  135,  135,  217,  214,  216,
      135,  218,  220,  149,  219,  166,  223,  161,  152,  105,

      105,  221,  215,  135,  135,  224,  229,  135,  135,  135,
      135,  228,  214,  216,  135,  218,  231,  220,  222,  219,
      223,  135,  105,  105,  105,  221,  169,  169,  135,  224,
      229,  135,  158,  158,  158,  230,  228,  167,  232,  382,
      150,  231,  222,  132,  162,  135,  171,  171,  171,  183,
      184,  183,  188,  189,  188,  250,  251,  190,  382,  230,
      209,  210,  209,  232,  185,  185,  186,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  187,  187,  187,  187,  187,  187,  187,

      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  185,  185,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  185,
      185,  185,  188,  189,  188,  239,  241,  190,  191,  189,
      191,  240,  242,  192,  243,  244,  245,  246,  247,  196,
      248,  249,  211,  210,  211,  102,  135,  253,  175,  254,
      239,  241,  135,  255,  256,  240,  174,  242,  243,  244,
      245,  246,  135,  247,  248,  249,  135,  135,  259,  135,
      135,  265,  253,  254,  257,  135,  135,  266,  255,  256,

      258,  135,  260,  135,  262,  261,  135,  135,  263,  267,
      135,  135,  259,  135,  135,  265,  268,  269,  257,  135,
      149,  266,  270,  274,  258,  135,  260,  135,  262,  271,
      261,  135,  263,  267,  264,  264,  272,  273,  135,  275,
      268,  269,  276,  250,  251,  382,  382,  270,  274,  279,
      277,  382,  135,  271,  135,  135,  280,  281,  168,  282,
      272,  273,  278,  275,  135,  283,  276,  150,  135,  135,
      135,  284,  285,  279,  135,  159,  135,  286,  135,  135,
      280,  135,  281,  282,  287,  149,  290,  135,  135,  283,
      289,  292,  135,  135,  135,  284,  291,  285,  135,  288,

      288,  286,  293,  296,  299,  135,  297,  298,  287,  300,
      290,  135,  294,  294,  294,  289,  292,  303,  135,  149,
      291,  156,  295,  304,  306,  311,  293,  307,  296,  299,
      297,  298,  150,  135,  300,  305,  135,  135,  135,  308,
      312,  303,  135,  294,  294,  294,  309,  155,  304,  306,
      311,  307,  310,  295,  155,  135,  315,  135,  320,  305,
      135,  135,  135,  308,  312,  135,  150,  152,  313,  313,
      313,  309,  316,  316,  316,  321,  104,  310,  314,  135,
      315,  322,  317,  320,  135,  294,  294,  294,  323,  135,
      318,  318,  318,  109,  301,  295,  302,  326,  135,  321,

      319,  313,  313,  313,  104,  322,  331,  334,  135,  327,
      332,  314,  323,  316,  316,  316,  318,  318,  318,  333,
      135,  326,  135,  317,  135,  135,  319,  135,  328,  329,
      331,  330,  334,  332,  327,  313,  313,  313,  102,  382,
      336,  335,  135,  333,  135,  314,  135,  342,  135,  135,
      337,  135,  328,  329,  135,  330,  135,  135,  316,  316,
      316,  318,  318,  318,  335,  336,  135,  338,  317,  341,
      135,  319,  342,  135,  337,  135,  340,  345,  135,  352,
      135,  135,  339,  382,  227,  135,  343,  343,  343,  227,
      227,  382,  338,  341,  353,  360,  344,  135,  382,  135,

      382,  340,  345,  352,  382,  339,  346,  346,  346,  135,
      348,  348,  348,  343,  343,  343,  347,  350,  353,  360,
      349,  382,  135,  344,  346,  346,  346,  348,  348,  348,
      343,  343,  343,  355,  347,  354,  356,  349,  135,  357,
      344,  358,  350,  346,  346,  346,  135,  348,  348,  348,
      135,  382,  361,  347,  135,  135,  362,  349,  355,  354,
      363,  356,  135,  365,  357,  135,  358,  369,  135,  367,
      364,  382,  366,  135,  135,  135,  361,  368,  135,  135,
      371,  362,  370,  135,  373,  363,  135,  365,  135,  135,
      375,  369,  135,  372,  367,  364,  366,  135,  374,  135,

      135,  376,  368,  377,  371,  378,  370,  135,  373,  379,
      135,  382,  135,  135,  135,  375,  135,  372,  380,  381,
      382,  382,  374,  382,  135,  382,  376,  382,  377,  382,
      378,  382,  382,  379,  382,  382,  382,  135,  135,  382,
      135,  382,  380,  382,  382,  382,  382,  382,  382,  382,
      135,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  135,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   68,   68,   68,

       68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
       68,   68,   68,   68,   68,   68,   68,   68,   68,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,  100,  382,  382,  382,  100,  100,  100,  100,  100,
      100,  100,  100,  100,  100,  100,  100,  100,  100,  100,
      100,  100,  100,  101,  101,  101,  101,  101,  101,  101,
      101,  101,  101,  101,  101,  101,  101,  101,  101,  101,
      101,  101,  101,  101,  101,  103,  103,  103,  103,  105,
      105,  382,  105,  105,  105,  105,  105,  105,  105,  105,

      105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
      105,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  108,  110,  110,  110,  382,  110,  110,  382,
      110,  382,  110,  110,  110,  110,  110,  111,  111,  382,
      382,  382,  111,  111,  111,  111,  124,  382,  124,  382,
      382,  382,  124,  124,  382,  124,  382,  382,  382,  124,
      382,  382,  124,  124,  124,  124,  127,  382,  127,  382,
      127,  127,  382,  382,  382,  382,  127,  127,  127,  127,
      130,  382,  382,  130,  130,  130,  130,  130,  382,  382,

      130,  130,  130,  130,  131,  131,  382,  131,  131,  131,
      131,  131,  131,  131,  131,  131,  131,  131,  131,  131,
      131,  131,  131,  131,  131,  131,  134,  382,  382,  382,
      134,  382,  134,  134,  382,  382,  382,  134,  134,  134,
      134,  135,  135,  135,  135,  135,  135,  135,  382,  135,
      382,  135,  135,  135,  135,  135,  148,  148,  148,  148,
      148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
      148,  148,  148,  148,  148,  148,  148,  148,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,

      153,  153,  153,  382,  382,  382,  153,  153,  153,  153,
      153,  154,  154,  154,  154,  154,  154,  154,  382,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  157,  382,  382,  382,  157,  157,  157,
      157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
      157,  157,  157,  157,  157,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  164,  382,  164,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      164,  164,  164,  164,  165,  165,  165,  165,  165,  165,

      165,  165,  165,  165,  165,  165,  165,  165,  165,  165,
      165,  165,  165,  165,  165,  165,  176,  176,  382,  382,
      382,  176,  176,  176,  176,  176,  193,  193,  193,  193,
      193,  193,  193,  193,  193,  193,  193,  193,  193,  193,
      193,  193,  193,  193,  193,  193,  193,  193,  195,  195,
      382,  195,  195,  195,  195,  195,  195,  195,  195,  195,
      195,  195,  195,  195,  195,  195,  195,  195,  195,  195,
      133,  382,  382,  382,  133,  382,  382,  382,  382,  382,
      382,  133,  133,  133,  133,  208,  382,  382,  208,  382,
      208,  382,  208,  208,  382,  382,  208,  208,  208,  208,

      208,  208,  131,  131,  131,  131,  131,  131,  131,  131,
      131,  131,  131,  131,  131,  131,  131,  131,  131,  131,
      131,  131,  131,  131,  134,  382,  382,  382,  382,  382,
      134,  134,  382,  134,  134,  134,  382,  382,  134,  134,
      134,  134,  148,  382,  382,  382,  382,  382,  382,  148,
      382,  382,  382,  382,  148,  382,  382,  148,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      153,  153,  153,  382,  382,  382,  153,  153,  153,  153,
      153,  154,  154,  154,  154,  154,  154,  154,  382,  154,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  157,  382,  382,  382,  157,  157,  157,
      157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
      157,  157,  157,  157,  157,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  164,  164,  164,
      164,  226,  226,  226,  226,  382,  382,  382,  226,  226,
      226,  226,  226,  165,  165,  165,  165,  165,  165,  165,
      165,  165,  165,  165,  165,  165,  165,  165,  165,  165,
      165,  165,  165,  165,  165,  176,  176,  382,  382,  382,

      176,  176,  176,  176,  176,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  233,  233,  233,
      233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
      233,  233,  233,  233,  233,  233,  233,  233,  233,  105,
      105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
      105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
      105,  235,  235,  235,  235,  235,  235,  235,  235,  235,
      235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
      235,  235,  235,  236,  236,  382,  236,  236,  236,  236,

      236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
      236,  236,  236,  236,  236,  237,  237,  382,  237,  237,
      237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
      237,  237,  237,  237,  237,  237,  237,  195,  195,  382,
      195,  195,  195,  195,  195,  195,  195,  195,  195,  195,
      195,  195,  195,  195,  195,  195,  195,  195,  195,  238,
      238,  382,  238,  238,  238,  238,  238,  238,  238,  238,
      238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
      238,  208,  382,  382,  208,  382,  208,  382,  208,  208,
      382,  382,  208,  208,  208,  208,  208,  208,  252,  252,

      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  252,  252,  252,  252,  324,  324,  382,  324,
      324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
      324,  324,  324,  324,  324,  324,  324,  324,   13,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,

      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382
    } ;

static yyconst flex_int16_t yy_chk[2418] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    5,    6,    7,    7,    7,    8,
        8,    8,    9,   23,  379,    5,    6,   10,   23,    9,
        9,    9,   90,   90,   10,   10,   10,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   28,  356,   29,   30,   31,
       32,   45,   33,   34,   35,   36,  212,   32,   37,   42,
       45,   42,   42,   45,   45,   45,   99,   41,  212,   41,
       28,   29,   30,   31,  341,   32,   33,   34,   35,   36,
       41,   32,   41,   37,   49,   60,   52,   49,   41,   44,
       44,   99,   44,   44,   44,   44,   44,   44,   44,   44,
       44,   44,   44,   44,   44,   93,   50,   44,   49,   50,

       52,   49,   44,   44,   44,   44,   44,   44,   46,   46,
       78,   46,   46,   78,   46,   46,   46,   80,   46,   93,
       50,   51,   60,   50,  107,   77,   46,  325,   51,   51,
      324,   44,   44,   47,   47,  107,   47,   47,   95,   47,
       47,   47,   53,   47,   53,   54,   51,  278,   46,  278,
       54,   46,   51,   51,   44,   44,   44,   48,   48,   80,
       48,   48,   95,   48,   48,   48,   53,   48,   53,   54,
       96,   55,   77,   47,   54,   55,   56,   72,   72,   72,
       88,   88,   89,   89,   89,   56,   48,  302,   97,   98,
      100,  100,  100,  112,   96,   55,  113,   48,  114,   55,

      115,   56,  104,  104,  104,  117,  118,  104,  120,   56,
       48,   88,   97,   98,  106,  106,  106,  112,  277,  106,
      113,  235,  114,  124,  115,  124,  124,  150,  150,  117,
      277,  118,  120,  233,   88,  103,  103,  103,  103,  103,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,

      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      103,  103,  103,  119,  192,  121,  122,  127,  190,  127,
      127,  123,  119,  123,  129,  185,  129,  129,  167,  130,
      130,  130,  162,  133,  123,  155,  123,  133,  119,  121,
      122,  130,  123,  135,  154,  133,  119,  131,  131,  131,
      131,  131,  131,  131,  131,  131,  131,  131,  131,  131,
      131,  131,  131,  140,  134,  131,  136,  135,  136,  136,
      131,  131,  131,  131,  131,  131,  134,  134,  138,  138,
      134,  134,  134,  134,  137,  141,  139,  140,  137,  139,
      142,  142,  144,  148,  143,  165,  146,  160,  151,  131,

      131,  144,  138,  138,  143,  147,  178,  147,  137,  141,
      139,  177,  137,  139,  142,  142,  181,  144,  145,  143,
      146,  145,  131,  131,  131,  144,  169,  169,  143,  147,
      178,  147,  158,  158,  158,  179,  177,  165,  182,  132,
      148,  181,  145,  126,  160,  145,  171,  171,  171,  183,
      183,  183,  188,  188,  188,  213,  213,  188,  125,  179,
      209,  209,  209,  182,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,

      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  189,  189,  189,  197,  199,  189,  191,  191,
      191,  198,  200,  191,  201,  202,  203,  204,  205,  111,
      206,  207,  211,  211,  211,  101,  215,  214,   92,  215,
      197,  199,  214,  216,  217,  198,   91,  200,  201,  202,
      203,  204,  216,  205,  206,  207,  217,  220,  220,  218,
      215,  229,  214,  215,  218,  219,  214,  231,  216,  217,

      219,  221,  221,  223,  223,  222,  216,  224,  224,  232,
      217,  220,  220,  218,  222,  229,  239,  240,  218,  219,
      225,  231,  242,  246,  219,  221,  221,  223,  223,  243,
      222,  224,  224,  232,  225,  225,  244,  245,  222,  247,
      239,  240,  249,  250,  250,  251,  251,  242,  246,  253,
      252,  252,  254,  243,  255,  257,  254,  256,   87,  257,
      244,  245,  252,  247,  262,  258,  249,  225,  258,  259,
      256,  259,  260,  253,  261,   76,  254,  261,  255,  257,
      254,  260,  256,  257,  263,  264,  266,  263,  262,  258,
      265,  269,  258,  259,  256,  259,  268,  260,  261,  264,

      264,  261,  270,  272,  275,  260,  273,  274,  263,  276,
      266,  263,  271,  271,  271,  265,  269,  279,  279,  288,
      268,   67,  271,  280,  283,  289,  270,  284,  272,  275,
      273,  274,  264,  283,  276,  281,  280,  285,  281,  285,
      290,  279,  279,  282,  282,  282,  286,   66,  280,  283,
      289,  284,  287,  282,   65,  286,  292,  283,  297,  281,
      280,  285,  281,  285,  290,  287,  288,   61,  291,  291,
      291,  286,  293,  293,  293,  298,   43,  287,  291,  286,
      292,  299,  293,  297,  282,  294,  294,  294,  300,  287,
      296,  296,  296,   25,  301,  294,  301,  304,  304,  298,

      296,  303,  303,  303,   22,  299,  311,  320,  282,  307,
      312,  303,  300,  305,  305,  305,  306,  306,  306,  315,
      307,  304,  304,  305,  308,  309,  306,  310,  308,  309,
      311,  310,  320,  312,  307,  313,  313,  313,   18,   13,
      323,  321,  303,  315,  307,  313,  326,  332,  308,  309,
      326,  310,  308,  309,  305,  310,  329,  306,  316,  316,
      316,  318,  318,  318,  321,  323,  303,  327,  316,  331,
      326,  318,  332,  328,  326,  327,  330,  334,  305,  342,
      329,  306,  328,    0,  423,  330,  333,  333,  333,  423,
      423,    0,  327,  331,  345,  357,  333,  328,    0,  327,

        0,  330,  334,  342,    0,  328,  335,  335,  335,  330,
      336,  336,  336,  337,  337,  337,  335,  338,  345,  357,
      336,    0,  338,  337,  339,  339,  339,  340,  340,  340,
      343,  343,  343,  351,  339,  350,  352,  340,  350,  353,
      343,  354,  338,  346,  346,  346,  338,  348,  348,  348,
      354,    0,  358,  346,  337,  358,  359,  348,  351,  350,
      360,  352,  350,  363,  353,  339,  354,  367,  340,  365,
      361,    0,  364,  364,  354,  361,  358,  366,  337,  358,
      369,  359,  368,  368,  371,  360,  366,  363,  370,  339,
      373,  367,  340,  370,  365,  361,  364,  364,  372,  361,

      372,  374,  366,  375,  369,  376,  368,  368,  371,  377,
      366,    0,  370,  374,  376,  373,  378,  370,  378,  380,
        0,    0,  372,    0,  372,    0,  374,    0,  375,    0,
      376,    0,    0,  377,    0,    0,    0,  374,  376,    0,
      378,    0,  378,    0,    0,    0,    0,    0,    0,    0,
      380,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  380,  383,  383,  383,  383,  383,
      383,  383,  383,  383,  383,  383,  383,  383,  383,  383,
      383,  383,  383,  383,  383,  383,  383,  384,  384,  384,

      384,  384,  384,  384,  384,  384,  384,  384,  384,  384,
      384,  384,  384,  384,  384,  384,  384,  384,  384,  385,
      385,  385,  385,  385,  385,  385,  385,  385,  385,  385,
      385,  385,  385,  385,  385,  385,  385,  385,  385,  385,
      385,  386,    0,    0,    0,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  387,  387,  387,  387,  387,  387,  387,
      387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
      387,  387,  387,  387,  387,  388,  388,  388,  388,  389,
      389,    0,  389,  389,  389,  389,  389,  389,  389,  389,

      389,  389,  389,  389,  389,  389,  389,  389,  389,  389,
      389,  390,  390,  390,  390,  390,  390,  390,  390,  390,
      390,  390,  390,  390,  390,  390,  390,  390,  390,  390,
      390,  390,  390,  391,  391,  391,    0,  391,  391,    0,
      391,    0,  391,  391,  391,  391,  391,  392,  392,    0,
        0,    0,  392,  392,  392,  392,  393,    0,  393,    0,
        0,    0,  393,  393,    0,  393,    0,    0,    0,  393,
        0,    0,  393,  393,  393,  393,  394,    0,  394,    0,
      394,  394,    0,    0,    0,    0,  394,  394,  394,  394,
      395,    0,    0,  395,  395,  395,  395,  395,    0,    0,

      395,  395,  395,  395,  396,  396,    0,  396,  396,  396,
      396,  396,  396,  396,  396,  396,  396,  396,  396,  396,
      396,  396,  396,  396,  396,  396,  397,    0,    0,    0,
      397,    0,  397,  397,    0,    0,    0,  397,  397,  397,
      397,  398,  398,  398,  398,  398,  398,  398,    0,  398,
        0,  398,  398,  398,  398,  398,  399,  399,  399,  399,
      399,  399,  399,  399,  399,  399,  399,  399,  399,  399,
      399,  399,  399,  399,  399,  399,  399,  399,  400,  400,
      400,  400,  400,  400,  400,  400,  400,  400,  400,  400,
      400,  400,  400,  400,  400,  400,  400,  400,  400,  400,

      401,  401,  401,    0,    0,    0,  401,  401,  401,  401,
      401,  402,  402,  402,  402,  402,  402,  402,    0,  402,
      402,  402,  402,  402,  402,  402,  402,  402,  402,  402,
      402,  402,  402,  403,    0,    0,    0,  403,  403,  403,
      403,  403,  403,  403,  403,  403,  403,  403,  403,  403,
      403,  403,  403,  403,  403,  404,  404,  404,  404,  404,
      404,  404,  404,  404,  404,  404,  404,  404,  404,  404,
      404,  404,  404,  404,  404,  404,  404,  405,    0,  405,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      405,  405,  405,  405,  406,  406,  406,  406,  406,  406,

      406,  406,  406,  406,  406,  406,  406,  406,  406,  406,
      406,  406,  406,  406,  406,  406,  407,  407,    0,    0,
        0,  407,  407,  407,  407,  407,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  409,  409,
        0,  409,  409,  409,  409,  409,  409,  409,  409,  409,
      409,  409,  409,  409,  409,  409,  409,  409,  409,  409,
      410,    0,    0,    0,  410,    0,    0,    0,    0,    0,
        0,  410,  410,  410,  410,  411,    0,    0,  411,    0,
      411,    0,  411,  411,    0,    0,  411,  411,  411,  411,

      411,  411,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  412,  412,  413,    0,    0,    0,    0,    0,
      413,  413,    0,  413,  413,  413,    0,    0,  413,  413,
      413,  413,  414,    0,    0,    0,    0,    0,    0,  414,
        0,    0,    0,    0,  414,    0,    0,  414,  415,  415,
      415,  415,  415,  415,  415,  415,  415,  415,  415,  415,
      415,  415,  415,  415,  415,  415,  415,  415,  415,  415,
      416,  416,  416,    0,    0,    0,  416,  416,  416,  416,
      416,  417,  417,  417,  417,  417,  417,  417,    0,  417,

      417,  417,  417,  417,  417,  417,  417,  417,  417,  417,
      417,  417,  417,  418,    0,    0,    0,  418,  418,  418,
      418,  418,  418,  418,  418,  418,  418,  418,  418,  418,
      418,  418,  418,  418,  418,  419,  419,  419,  419,  419,
      419,  419,  419,  419,  419,  419,  419,  419,  419,  419,
      419,  419,  419,  419,  419,  419,  419,  420,  420,  420,
      420,  421,  421,  421,  421,    0,    0,    0,  421,  421,
      421,  421,  421,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  422,  424,  424,    0,    0,    0,

      424,  424,  424,  424,  424,  425,  425,  425,  425,  425,
      425,  425,  425,  425,  425,  425,  425,  425,  425,  425,
      425,  425,  425,  425,  425,  425,  425,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  427,
      427,  427,  427,  427,  427,  427,  427,  427,  427,  427,
      427,  427,  427,  427,  427,  427,  427,  427,  427,  427,
      427,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  429,  429,    0,  429,  429,  429,  429,

      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
      429,  429,  429,  429,  429,  430,  430,    0,  430,  430,
      430,  430,  430,  430,  430,  430,  430,  430,  430,  430,
      430,  430,  430,  430,  430,  430,  430,  431,  431,    0,
      431,  431,  431,  431,  431,  431,  431,  431,  431,  431,
      431,  431,  431,  431,  431,  431,  431,  431,  431,  432,
      432,    0,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  432,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  433,    0,    0,  433,    0,  433,    0,  433,  433,
        0,    0,  433,  433,  433,  433,  433,  433,  434,  434,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  434,  434,  434,  434,  435,  435,    0,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,

      382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
      382,  382,  382,  382,  382,  382,  382
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[82] =
    {   0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 
    1, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 
    0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
/* Lex file for rsyslog config format v2 (RainerScript).
* Please note: this file introduces the new config format, but maintains
* backward compatibility. In order to do so, the grammar is not 100% clean,
* but IMHO still sufficiently easy both to understand for programmers
* maitaining the code as well as users writing the config file. Users are,
* of course, encouraged to use new constructs only. But it needs to be noted
* that some of the legacy constructs (specifically the in-front-of-action
* PRI filter) are very hard to beat in ease of use, at least for simpler
* cases. So while we hope that cfsysline support can be dropped some time in
* the future, we will probably keep these useful constructs.
*
* Copyright 2011-2012 Rainer Gerhards and Adiscon GmbH.
*
* This file is part of the rsyslog runtime library.
*
* The rsyslog runtime library is free software: you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* The rsyslog runtime library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with the rsyslog runtime library.  If not, see <http://www.gnu.org/licenses/>.
*
* A copy of the GPL can be found in the file "COPYING" in this distribution.
* A copy of the LGPL can be found in the file "COPYING.LESSER" in this distribution.
*/
/*%option noyywrap nodefault case-insensitive */
/* avoid compiler warning: `yyunput' defined but not used */
#define YY_NO_INPUT 1

/* INOBJ is selected if we are inside an object (name/value pairs!) */

/* COMMENT is "the usual trick" to handle C-style comments */

/* INCL is in $IncludeConfig processing (skip to include file) */

/* LINENO: support for setting the linenumber */

/* EXPR is a bit ugly, but we need it to support pre v6-syntax. The problem
* is that cfsysline statement start with $..., the same like variables in
* an expression. However, cfsysline statements can never appear inside an
* expression. So we create a specific expr mode, which is turned on after 
* we lexed a keyword that needs to be followed by an expression (using 
* knowledge from the upper layer...). In expr mode, we strictly do
* expression-based parsing. Expr mode is stopped when we reach a token
* that can not be part of an expression (currently only "then"). As I
* wrote this ugly, but the price needed to pay in order to remain
* compatible to the previous format.
*/
#line 61 "lexer.l"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <libestr.h>
#include "rainerscript.h"
#include "parserif.h"
#include "grammar.h"
static int preCommentState;	/* save for lex state before a comment */

struct bufstack {
	struct bufstack *prev;
	YY_BUFFER_STATE bs;
	int lineno;
	char *fn;
	es_str_t *estr;
} *currbs = NULL;

char *cnfcurrfn;			/* name of currently processed file */

int popfile(void);
int cnfSetLexFile(char *fname);

extern int yydebug;

/* somehow, I need these prototype even though the headers are 
 * included. I guess that's some autotools magic I don't understand...
 */
//char *strdup(char*);
int fileno(FILE *stream);

#line 1241 "lexer.c"

#define INITIAL 0
#define INOBJ 1
#define COMMENT 2
#define INCL 3
#define LINENO 4
#define EXPR 5

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 94 "lexer.l"


 /* keywords */
#line 1438 "lexer.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 383 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 2339 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 97 "lexer.l"
{ BEGIN EXPR; return IF; }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 98 "lexer.l"
{ BEGIN INITIAL; return THEN; }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 99 "lexer.l"
{ return OR; }
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 100 "lexer.l"
{ return AND; }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 101 "lexer.l"
{ return NOT; }
	YY_BREAK
case 6:
#line 103 "lexer.l"
case 7:
#line 104 "lexer.l"
case 8:
#line 105 "lexer.l"
case 9:
#line 106 "lexer.l"
case 10:
#line 107 "lexer.l"
case 11:
#line 108 "lexer.l"
case 12:
#line 109 "lexer.l"
case 13:
YY_RULE_SETUP
#line 109 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 110 "lexer.l"
{ return CMP_EQ; }
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 111 "lexer.l"
{ return CMP_LE; }
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 112 "lexer.l"
{ return CMP_GE; }
	YY_BREAK
case 17:
#line 114 "lexer.l"
case 18:
YY_RULE_SETUP
#line 114 "lexer.l"
{ return CMP_NE; }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 115 "lexer.l"
{ return CMP_LT; }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 116 "lexer.l"
{ return CMP_GT; }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 117 "lexer.l"
{ return CMP_CONTAINS; }
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 118 "lexer.l"
{ return CMP_CONTAINSI; }
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 119 "lexer.l"
{ return CMP_STARTSWITH; }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 120 "lexer.l"
{ return CMP_STARTSWITHI; }
	YY_BREAK
case 25:
#line 122 "lexer.l"
case 26:
#line 123 "lexer.l"
case 27:
YY_RULE_SETUP
#line 123 "lexer.l"
{ yylval.n = strtoll(yytext, NULL, 0); return NUMBER; }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 124 "lexer.l"
{ yylval.s = strdup(yytext); return VAR; }
	YY_BREAK
case 29:
/* rule 29 can match eol */
YY_RULE_SETUP
#line 125 "lexer.l"
{ yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				   return STRING; }
	YY_BREAK
case 30:
/* rule 30 can match eol */
YY_RULE_SETUP
#line 127 "lexer.l"
{ yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				   return STRING; }
	YY_BREAK
case 31:
/* rule 31 can match eol */
YY_RULE_SETUP
#line 129 "lexer.l"

	YY_BREAK
case 32:
YY_RULE_SETUP
#line 130 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return FUNC; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 132 "lexer.l"
{ dbgprintf("invalid char in expr: %s\n", yytext); }
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 133 "lexer.l"
{ return '&'; }
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 134 "lexer.l"
{ return '{'; }
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 135 "lexer.l"
{ return '}'; }
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 136 "lexer.l"
{ dbgprintf("RULESET\n"); }
	YY_BREAK
/* line number support because the "preprocessor" combines lines and so needs
  * to tell us the real source line.
  */
case 38:
YY_RULE_SETUP
#line 140 "lexer.l"
{ return STOP; }
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 141 "lexer.l"
{ return ELSE; }
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 142 "lexer.l"
{ BEGIN LINENO; }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 143 "lexer.l"
{ yylineno = atoi(yytext) - 1; }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 144 "lexer.l"
{ BEGIN INITIAL; }
	YY_BREAK
case 43:
/* rule 43 can match eol */
YY_RULE_SETUP
#line 145 "lexer.l"

	YY_BREAK
/* $IncludeConfig must be detected as part of CFSYSLINE, because this is
  * always the longest match :-(
  */
case 44:
/* rule 44 can match eol */
YY_RULE_SETUP
#line 149 "lexer.l"

	YY_BREAK
case 45:
YY_RULE_SETUP
#line 150 "lexer.l"
{ if(cnfDoInclude(yytext) != 0)
					yyterminate();
				  BEGIN INITIAL; }
	YY_BREAK
case 46:
/* rule 46 can match eol */
YY_RULE_SETUP
#line 153 "lexer.l"
{ yylval.objType = CNFOBJ_GLOBAL;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 47:
/* rule 47 can match eol */
YY_RULE_SETUP
#line 155 "lexer.l"
{ yylval.objType = CNFOBJ_TPL;
				  BEGIN INOBJ; return BEGIN_TPL; }
	YY_BREAK
case 48:
/* rule 48 can match eol */
YY_RULE_SETUP
#line 157 "lexer.l"
{ yylval.objType = CNFOBJ_PROPERTY;
				  BEGIN INOBJ; return BEGIN_PROPERTY; }
	YY_BREAK
case 49:
/* rule 49 can match eol */
YY_RULE_SETUP
#line 159 "lexer.l"
{ yylval.objType = CNFOBJ_CONSTANT;
				  BEGIN INOBJ; return BEGIN_CONSTANT; }
	YY_BREAK
case 50:
/* rule 50 can match eol */
YY_RULE_SETUP
#line 161 "lexer.l"
{ yylval.objType = CNFOBJ_INPUT;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 51:
/* rule 51 can match eol */
YY_RULE_SETUP
#line 163 "lexer.l"
{ yylval.objType = CNFOBJ_MODULE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
#line 165 "lexer.l"
{ BEGIN INOBJ; return BEGIN_ACTION; }
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 166 "lexer.l"
{
				  yylval.s = strdup(rmLeadingSpace(yytext)); return PROPFILT; }
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 168 "lexer.l"
{ yylval.s = strdup(rmLeadingSpace(yytext)); return PRIFILT; }
	YY_BREAK
case 55:
#line 170 "lexer.l"
case 56:
#line 171 "lexer.l"
case 57:
/* rule 57 can match eol */
#line 172 "lexer.l"
case 58:
/* rule 58 can match eol */
#line 173 "lexer.l"
case 59:
/* rule 59 can match eol */
#line 174 "lexer.l"
case 60:
/* rule 60 can match eol */
#line 175 "lexer.l"
case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 175 "lexer.l"
{ yylval.s = yytext; return LEGACY_ACTION; }
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 176 "lexer.l"
{ BEGIN INITIAL; return ENDOBJ; }
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 177 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return NAME; }
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 179 "lexer.l"
{ return(yytext[0]); }
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 180 "lexer.l"
{
				  yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				  return VALUE; }
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 183 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 184 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 185 "lexer.l"
{ BEGIN preCommentState; }
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 186 "lexer.l"

	YY_BREAK
case 70:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 187 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 188 "lexer.l"

	YY_BREAK
case 72:
YY_RULE_SETUP
#line 189 "lexer.l"
{ dbgprintf("INOBJ: invalid char '%s'\n", yytext); }
	YY_BREAK
case 73:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 190 "lexer.l"
{ /* see comment on $IncludeConfig above */
				  if(!strncasecmp(yytext, "$includeconfig ", 14)) {
					yyless(14);
				  	BEGIN INCL;
				  } else if(!strncasecmp(yytext, "$ruleset ", 9)) {
					yylval.s = strdup(yytext);
					return LEGACY_RULESET;
				  } else {
					  cnfDoCfsysline(strdup(yytext)); 
				  }
				}
	YY_BREAK
case 74:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 201 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_TAG_SELECTOR; }
	YY_BREAK
case 75:
/* rule 75 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 202 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 76:
/* rule 76 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 203 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 77:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 204 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 78:
/* rule 78 can match eol */
YY_RULE_SETUP
#line 205 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 206 "lexer.l"
/* drop whitespace */
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 207 "lexer.l"
{ dbgprintf("invalid char: %s\n", yytext);
				}
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(INOBJ):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(INCL):
case YY_STATE_EOF(LINENO):
case YY_STATE_EOF(EXPR):
#line 209 "lexer.l"
{ if(popfile() != 0) yyterminate(); }
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 211 "lexer.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 1972 "lexer.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 383 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 383 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 382);

	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 211 "lexer.l"


int
cnfParseBuffer(char *buf, unsigned lenBuf)
{
	struct bufstack *bs;
	int r = 0;
	yydebug = 1;
	BEGIN INITIAL;
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup("*buffer*");
	bs->bs = yy_scan_buffer(buf,lenBuf);
	bs->estr = NULL;
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
done:	return r;
}

/* set a new buffers. Returns 0 on success, something else otherwise. */
int
cnfSetLexFile(char *fname)
{
	es_str_t *str = NULL;
	FILE *fp;
	int r = 0;
	struct bufstack *bs;

	if(fname == NULL) {
		fp = stdin;
	} else {
		if((fp = fopen(fname, "r")) == NULL) {
			r = 1;
			goto done;
		}
	}
	readConfFile(fp, &str);
	if(fp != stdin)
		fclose(fp);
	
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup(fname == NULL ? "stdin" : fname);
	bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),es_strlen(str));
	bs->estr = str; /* needed so we can free it later */
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;

done:
	if(r != 0) {
		if(str != NULL)
			es_deleteStr(str);
	}
	return r;
}


/* returns 0 on success, something else otherwise */
int
popfile(void)
{
	struct bufstack *bs = currbs;

	if(bs == NULL)
		return 1;
	
	/* delete current entry. But we must not free the file name if
	 * this is the top-level file, because then it may still be used
	 * in error messages for other processing steps.
	 * TODO: change this to another method which stores the file
	 * name inside the config objects. In the longer term, this is
	 * necessary, as otherwise we may provide wrong file name information
	 * at the end of include files as well. -- rgerhards, 2011-07-22
	 */
	yy_delete_buffer(bs->bs);
	if(bs->prev != NULL)
		free(bs->fn);
	free(bs->estr);

	/* switch back to previous */
	currbs = bs->prev;
	free(bs);

	if(currbs == NULL)
		return 1; /* all processed */
	
	yy_switch_to_buffer(currbs->bs);
	yylineno = currbs->lineno;
	cnfcurrfn = currbs->fn;
	return 0;
}

void
tellLexEndParsing(void)
{
	free(cnfcurrfn);
	cnfcurrfn= NULL;
}

